﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Telerik.WinControls.UI.Docking;
using Telerik.WinControls.UI;

namespace _517140
{
    public partial class Form1 : Form
    {
        bool allowClosing = false;

        public Form1()
        {
            InitializeComponent();

            ContextMenuService menuService = this.radDock1.GetService<ContextMenuService>();
            menuService.ContextMenuDisplaying += menuService_ContextMenuDisplaying;

            this.IsMdiContainer = true;
            this.radDock1.AutoDetectMdiChildren = true;
            radDock1.DockWindowAdded += new Telerik.WinControls.UI.Docking.DockWindowEventHandler(radDock1_DockWindowAdded);
            radDock1.DockWindowClosing += new Telerik.WinControls.UI.Docking.DockWindowCancelEventHandler(radDock1_DockWindowClosing);
        }

        private void menuService_ContextMenuDisplaying(object sender, ContextMenuDisplayingEventArgs e)
        {
            //remove the "Close" menu items
            for (int i = 0; i < e.MenuItems.Count; i++)
            {
                RadMenuItemBase menuItem = e.MenuItems[i];
                if (menuItem.Name == "CloseWindow" || menuItem.Name == "CloseAllButThis" || menuItem.Name == "CloseAll" || menuItem is RadMenuSeparatorItem)
                {
                    menuItem.Visibility = Telerik.WinControls.ElementVisibility.Collapsed;
                }
            }
        }

        void radDock1_DockWindowClosing(object sender, Telerik.WinControls.UI.Docking.DockWindowCancelEventArgs e)
        {
            if (!allowClosing)
            {
                //cancel closing except in cases where we called it
                e.Cancel = true;
            }
        }

        void radDock1_DockWindowAdded(object sender, Telerik.WinControls.UI.Docking.DockWindowEventArgs e)
        {
            //hide the close button
            ((HostWindow)e.DockWindow).DocumentButtons &= ~DocumentStripButtons.Close;
        }

        private void radButton1_Click(object sender, EventArgs e)
        {
            Form childForm = new Form();
            childForm.Text = "MDI Child " + DateTime.Now.ToShortTimeString();
            childForm.MdiParent = this;
            childForm.Show();
        }

        private void radButton2_Click(object sender, EventArgs e)
        {
            allowClosing = true;
            radDock1.CloseAllWindows();
            allowClosing = false;

        }
    }
}
